Subject: Re: Announcing Filespooler

From: John Goerzen <[email-masked]>
Date: Fri, 10 Jun 2022 15:46:20 -0500

On Fri, Jun 10 2022, Sergey Matveev wrote:

> *** John Goerzen [2022-06-10 08:14]:
>>Out of curiosity, what are your challenges with Rust?
>
> When I looked at it, it does not tell how to compile itself from the
> sources. Its official suggestion is just to download some prebuilt
> binary from the Internet and build Rust with it. So officially there is
> (was? I did not check it for several years, because of no trust because
> of all of that) no way to build it from the sources. Completely
> unacceptable in my opinion and no trust for its creators. As I remember,
> they wrote it initially on OCaml, that in turn was written on C.
>
> Just out of curiosity I tried mrustc to build at least some of Rust's
> version to be able to use it for bootstrapping further. I succeeded on
> Devuan, but could not build it on FreeBSD. So several years ago I just
> could not build it from the sources.

Thanks for this - you sent me down a path of exploring this.

rustc is written in Rust, as the Go compiler is written in Go.  (You are
correct that rustc was once written in OCaml, but nowadays it's Rust).

https://rustc-dev-guide.rust-lang.org/building/how-to-build-and-run.html
describes the process.  It does need a bootstrapping compiler, which is
described in
https://rustc-dev-guide.rust-lang.org/building/how-to-build-and-run.html
.

It looks like the story is similar with Go;
https://rustc-dev-guide.rust-lang.org/building/how-to-build-and-run.html
describes that "you need a Go compiler installed" to build it.

- John